var _worker, chunkify, chunkifyObj, flatten, fork, path, processWork, shuffle;

({fork} = require("child_process"));

path = require("path");

flatten = (arrs) => {
  var arr, j, k, len1, len2, obj, ref, target;
  target = [];
  for (j = 0, len1 = arrs.length; j < len1; j++) {
    arr = arrs[j];
    if (Array.isArray(arr)) {
      ref = flatten(arr);
      for (k = 0, len2 = ref.length; k < len2; k++) {
        obj = ref[k];
        target.push(obj);
      }
    } else {
      target.push(arr);
    }
  }
  return target;
};

chunkify = (arr, n) => {
  var i, len, out, size;
  if (n < 2) {
    return [arr];
  }
  len = arr.length;
  out = [];
  i = 0;
  if (len % n === 0) {
    size = Math.floor(len / n);
    while (i < len) {
      out.push(arr.slice(i, i += size));
    }
  } else {
    while (i < len) {
      size = Math.ceil((len - i) / n--);
      out.push(arr.slice(i, i += size));
    }
  }
  return out;
};

chunkifyObj = (prop, arr, n) => {
  var count, curr, i, j, k, len, len1, o, out, piece, ref, ref1, ref2, size, sorted, tmp, tmp2;
  if (n < 2) {
    o = arr[0];
    tmp = o.length = o[prop];
    o["_" + prop] = (function() {
      var results = [];
      for (var j = 0; 0 <= tmp ? j < tmp : j > tmp; 0 <= tmp ? j++ : j--){ results.push(j); }
      return results;
    }).apply(this);
    return [o];
  }
  len = arr.reduce(((acc, cur) => {
    return acc + cur[prop];
  }), 0);
  sorted = arr.sort((a, b) => {
    return a[prop] - b[prop];
  });
  out = [];
  for (j = 0, len1 = sorted.length; j < len1; j++) {
    piece = sorted[j];
    size = Math.ceil(len / n);
    len -= (tmp = piece[prop]);
    if (piece[prop] <= size) {
      piece.length = tmp;
      piece["_" + prop] = (function() {
        var results = [];
        for (var k = 0; 0 <= tmp ? k < tmp : k > tmp; 0 <= tmp ? k++ : k--){ results.push(k); }
        return results;
      }).apply(this);
      n--;
      out.push(piece);
    } else {
      count = Math.ceil(tmp / size);
      n -= count;
      size = Math.ceil(tmp / count);
      for (i = k = 0, ref = count; (0 <= ref ? k < ref : k > ref); i = 0 <= ref ? ++k : --k) {
        tmp2 = (function() {
          var results = [];
          for (var l = ref1 = size * i, ref2 = Math.min(tmp, size * (i + 1)); ref1 <= ref2 ? l < ref2 : l > ref2; ref1 <= ref2 ? l++ : l--){ results.push(l); }
          return results;
        }).apply(this);
        curr = Object.assign({
          length: tmp2.length
        }, piece);
        curr["_" + prop] = tmp2;
        curr[prop] = tmp2.length;
        out.push(curr);
      }
    }
  }
  return out;
};

shuffle = (array) => {
  var counter, index, temp;
  counter = array.length;
  while (0 < counter) {
    index = Math.floor(Math.random() * counter);
    counter--;
    temp = array[counter];
    array[counter] = array[index];
    array[index] = temp;
  }
  return array;
};

if (path.extname(__filename) === ".coffee") {
  _worker = `${__dirname}/_worker.coffee`;
} else {
  _worker = `${__dirname}/_worker.js`;
}

processWork = (work, options) => {
  var c, getLen, neededWorkers, remaining;
  if (options.flatten !== false) {
    work = flatten(work);
  }
  getLen = (arr) => {
    var prop;
    if ((prop = options.object)) {
      return arr.reduce(((acc, cur) => {
        return acc + cur[prop];
      }), 0);
    } else {
      return arr.length;
    }
  };
  if ((remaining = getLen(work)) > 0) {
    if (options.shuffle !== false) {
      work = shuffle(work);
    } else {
      work.reverse();
    }
    neededWorkers = Math.min(remaining, options.concurrency || require("os").cpus().length);
    c = options.chunkify;
    if (c == null) {
      if (options.object) {
        c = chunkifyObj.bind(null, options.object);
      } else {
        c = chunkify;
      }
    }
    work = c(work, Math.max(neededWorkers, remaining / Math.sqrt(2)));
  }
  return [remaining, neededWorkers, work];
};

module.exports = (work, options) => {
  return new Promise((resolve, reject) => {
    var current, i, j, neededWorkers, onText, ref, remaining, results, total, worker;
    if (!(options != null ? options.worker : void 0)) {
      reject(new Error("handle-that: no worker defined"));
    }
    [remaining, neededWorkers, work] = processWork(work, options);
    if ((total = remaining) > 0) {
      current = 0;
      if (options.onText != null) {
        options.silent = true;
      }
      if (options.cwd == null) {
        options.cwd = process.cwd();
      }
      if (options.end == null) {
        options.end = process.env;
      }
      results = [];
      for (i = j = 0, ref = neededWorkers; (0 <= ref ? j < ref : j > ref); i = 0 <= ref ? ++j : --j) {
        worker = fork(_worker, [path.resolve(options.worker), "--colors"], options);
        if ((onText = options.onText) != null) {
          ["stdout", "stderr"].forEach((std) => {
            std = worker[std];
            std.setEncoding("utf8");
            return std.on("data", (data) => {
              var lines;
              lines = data.split("\n");
              if (lines[lines.length - 1] === "") {
                lines.pop();
              }
              return onText(lines, remaining);
            });
          });
        }
        if (typeof options.onFork === "function") {
          options.onFork(worker);
        }
        worker.on("message", ((w, {done, cancel}) => {
          var pieces;
          if (cancel) {
            w.disconnect();
            if (--neededWorkers === 0) {
              if (typeof options.onFinish === "function") {
                options.onFinish();
              }
              return resolve();
            }
          } else if (done != null) {
            pieces = work.pop();
            if (done) {
              remaining -= done;
              if (remaining > 0) {
                if (typeof options.onProgress === "function") {
                  options.onProgress(remaining);
                }
              }
              if (remaining === 0) {
                if (typeof options.onFinish === "function") {
                  options.onFinish();
                }
                resolve();
              }
            }
            if (pieces) {
              w.send({
                pieces: pieces,
                current: current,
                length: total
              });
              return current += pieces.length;
            } else {
              --neededWorkers;
              return w.disconnect();
            }
          }
        }).bind(null, worker));
        results.push(worker.on("exit", (code) => {
          if (code === 1) {
            return reject(new Error("Worker exited unexpectedly"));
          }
        }));
      }
      return results;
    } else {
      return finish();
    }
  });
};

module.exports.shuffle = shuffle;

module.exports.chunkify = chunkify;

module.exports.chunkifyObj = chunkifyObj;

module.exports.flatten = flatten;

module.exports.processWork = processWork;
